
_TEXT segment para public 'CODE'
assume cs:_TEXT,ds:_TEXT,es:_TEXT
extrn top_of_mem:word
rootip  dw 0
rootcs  dw 0
root equ dword ptr rootip
public  rootip,rootcs
; fix memory map
; strategy is to go to the root and try to put things together
fixm:
public fixm
     push   es
     les    di,cs:root
     mov    ax,word ptr es:[di]
     mov    es,ax
     cmp    byte ptr es:[0],'M'
     je     got_m
     stc
     pop    es
     ret
got_m:
; ax has the current memory segment
     mov    bx,ax  ; save the current segment
     mov    es,ax
     add    ax,word ptr es:[3]
     inc    ax
     mov    es,ax
     cmp    byte ptr es:[0],'M'
     je     got_m
     cmp    byte ptr es:[0],'Z'
     je     done_root
     jmp    find_next_m
done_root:
     pop    es
     clc
     ret
find_next_m:
; bx has the address of the last good M
; strategy is to look at each segment until a valid block is
; found or top of memory
;
; we will take it for granted that the last M was good
; and that we are pointing to where a good block should start
;
     push ds
     mov  ds,ax
     mov  bx,ax
     mov  word ptr ds:[1],0
     mov  word ptr ds:[3],-1
     mov  byte ptr ds:[0],'M'
fn_m1:
     inc  ax
     inc  word ptr ds:[3]
     cmp  ax,top_of_mem
     je   make_z   ; will force a last memory block
     mov  es,ax
     mov  dl,byte ptr es:[0]
     cmp dl,'Z'
     je   got_z
     cmp dl,'M'
     jne  fn_m1
; got an 'M'
; if it points to a good memory segment then it is a memory segment
     push ax   ; save where we are
     add  ax,word ptr es:[3]
     inc  ax
     mov  es,ax
     mov  cl,byte ptr es:[0]
     cmp  cl,'M'
     je   found_m
     cmp  cl,'Z'
     je   found_m
     pop  ax
     jmp  fn_m1
found_m:
; found a valid memory guy,
     pop  ax
     mov  ax,ds
     pop  ds
     mov  bx,ax
     cmp  cl,'Z'
     jne  got_m
     pop  es
     clc
     ret
got_z:
; found a Z, is it the last guy
; if z[3]+ax = top_mem we're done
     push ax   ; save where we are
     add  ax,word ptr es:[3]
     inc  ax
     cmp  ax,top_of_mem
     pop  ax
     jne  fn_m1
; got our Z
     pop  ds
     pop  es
     clc
     ret
make_z:  ; will force a last memory block
     mov  byte ptr ds:[0],'Z'
     pop  ds
     pop  es
     clc
     ret
_TEXT  ends
     end
